# Der Algorithmus-Begriff

*Dateiname: algorithmus.md*

---

?>Du kennst die Algorithmeneigenschaften.<br />
 Du kannst entscheiden, ob ein gegebener Ablauf einem Algorithmus entspricht.<br />
 Du kennst die Bedeutung der Darstellung von Algorithmen mit Hilfe von Flussdiagrammen bzw. Struktogrammen.

---

## Algorithmus-Eigenschaften

i>**Definition**<br />Ein Algorithmus ist eine Verarbeitungsvorschrift (Anweisung zum Handeln) zur Lösung eines Problems (mit Hilfe eines Computers), die folgenden Anforderungen erfüllt:

- **Allgemeingültigkeit**, d.h. die Anweisungen besitzen Gültigkeit für die Lösung einer ganzen Klasse von Problemen, nicht nur ein Einzelproblem
- **Ausführbarkeit**, d.h. die Anweisungen sind für den Befehlsempfänger verständlich formuliert und für diesen ausführbar
- **Eindeutigkeit**, d.h. an jeder Stelle ist der Ablauf der Anweisungen eindeutig festgelegt
- **Finitheit**, d.h. die Anweisungsfolge ist durch einen endlichen Text beschrieben
- **Terminiertheit**, d.h. nach endlich vielen Schritten liefert die Anweisungsfolge eine Lösung des gestellten Problems
- **Determiniertheit**, d.h. bei jeder Ausführung mit gleichen Startbedingungen und Eingaben erhält man das gleiche Ergebnis

**Beispiele**
- Verfahren der schriftlichen Addition
- Testen eines Palindroms
- Spielregeln eines Gesellschaftsspiels

---

## Übung

t>**Aufgabe**<br />Vervollständige die Tabelle auch mit eigenen Beispielen. Finde dazu zwei Abläufe, die nicht den Anforderungen eines Algorithmus entsprechen.

Ablauf | Ist Algorithmus | ist kein Algorithmus, weil...
------ | --------------- | -----------------------------
Laufen im Kreis |  |  
Blindes Ziehen von 5 Kugeln aus einer Urne mit 8 Kugeln |  | 
... |   |  
... |   |  
... |   |  


t>**Aufgabe**<br />Testen wir mal dein Können in der interaktiven Übung.

<iframe src="https://learningapps.org/watch?app=3986858" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>


<iframe src="https://learningapps.org/watch?app=5060037" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>

<iframe src="https://learningapps.org/watch?app=11308502" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>

<iframe src="https://learningapps.org/watch?app=1192152" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>

## Darstellung von Algorithmen

Warum muss ein Algorithmus überhaupt "gezeichnet" werden?

i>Da es fast so viele Programmiersprachen wie Muttersprachen gibt, benötigt man einen "Dolmetscher". Dies ist die grafische Darstellung eines Algorithmus. Damit diese einheitlich umgesetzt wird, hat man sich auf Standards geeinigt, dies ist das **Struktogramm** (Nassi-Shneiderman-Diagramm) und das **Flussdiagramm**.

**Struktogramm**

![alternativ](https://upload.wikimedia.org/wikipedia/commons/3/33/NassiShneiderman.png)

*Quelle: https://upload.wikimedia.org/wikipedia/commons/3/33/NassiShneiderman.png, abgerufen am 31.08.2020*

**Flussdiagramm**

![alternativtext](bilder/verzweigungEinfuehrung.png)

Im Unterricht werden wir uns auf das Zeichnen von Flussdiagrammen konzentrieren. Wobei zeichnen hier relativ zu sehen ist. Mit Hilfe des Programms *flowAlgorithm* (Desktop/Informatik) werden wir entsprechende Algorithmen entwickeln.

