# Funktionen mit Rückgabewert

*Dateiname: eigene_Funktionen_Ruckgabewert.md*

![Code Einführung Unterprogramme](bilder/code_php.png)

Du kannst nicht nur einer Funktion Informationen mit auf den Weg geben, sondern du kannst auch eine Information zurückbekommen (genau eine!). Das ist der sogenannte **Rückgabewert**.

## Rückgabewert definieren

Nehmen wir an, du willst eine komplexe Rechnung mit einer Funktion abhandeln, z.B. die Quadratzahl einer Zahl zu berechnen. Dann definierst du:

```
float quadratzahl(float x) {
   float erg = x * x;
   return erg;
}
```

Du siehst hier zwei neue Dinge. Erstens steht da anstatt **void** jetzt **float**. Zweitens siehst du das Wort **return**.

Das `float` bedeutet, dass diese Funktionen einen Wert vom Typ float zurückgibt. Wohingegen `void` (engl. für "nichts") bedeutet, dass eine Funktion *keinen* Wert zurückgibt.

Damit du Processing nun sagen kannst, was genau du zurückgegeben werden soll (und wann), gibt es das Schlüsselwort `return`. Im Beispiel definierst du eine neue lokale Variable namens `erg`. Diese Variable ist nur gültig bis zur nächsten schließenden geschweiften Klammer. Das heißt, jeglicher Code unterhalb von `return` ist sinnlos:

```
float quadratzahl(float x) {
   float erg = x * x;
   return erg; // Processing gibt Wert zurück und bricht ab
   println("bin ich jetzt dran?"); // wird nie ausgeführt
}
```

s>Tipp: Hinter `return` könnne auch ganze Ausdrücke stehen, d.h. in kurz wäre es so:

```
float quadratzahl(float x) {
   return x * x;
}
```

### Rückgabewert im Code verwenden.

Beim **Aufruf** einer Funktion mit Rückgabewert wird der Aufruf durch den Rückgabewert **ersetzt**. Insofern ähnelt dies dem Prinzip einer Variable, die durch deinen Inhalt ersetzt wird.

Aus

```
println(quadratzahl(5));
```

wird

```
println(25);
```

Rückgabewerte werden häufig zunächst an Variablen gebunden und dann weiter verarbeitet.

```
float z = quadratzahl(5);
println("Ergebnis: " + z);
```

Du kannst aber den Funktionsaufruf auch direkt als Parameter für eine andere Funktion einbinden:

```
println("Ergebnis: " + quadratzahl(5));
```

## Übung

t>Programmiere eine Fakultätsfunktion `fakN()`.

t>Schreibe eine Funktion `wuerfeln()`, mit der man zufällig eine ganze Zahl zwischen 1 und 6 erhält.

t>Schreibe eine Funktion, welche durch Eingabe der 3 Seitenlänge eines Dreiecks prüft, ob es sich wirklich um ein Dreieck handelt.

t>Schreibe eine Funktion `pyTripel()`, welche durch Eingabe von 3 ganzen Zahlen prüft, ob es sich um ein pythagoräisches Tripel handelt.

*Hinweis: ein pythagoräisches Tripel sind ganze Zahlen, die der Gesetzmäßigkeit des Satz des Pythagoras entsprechen. Beispiele (3,4,5) (12, 35, 37) (13, 84, 85)*
