# Fehlermeldungen

*Dateiname: fehlermeldungen.md*

## Typische Fehler

![Fehlermeldung im Debugger](bilder/fehlermeldung_debugger.png)

Man sollte sich nicht wundern, falls der Debugger einen Fehler meldet. Wichtig ist nur, genau zu lesen, um welchen Fehler es sich handelt. Hier einige typische Beispiele

Eingegebener Quelltext | Fehlermeldung | Anmerkung
---------------------- | ------------- | ---------
int zahl=50 | Missing a semicolon ";" | Jeder Befehl wird durch ein Semikolon abgeschlossen
void draw(){ | Missing right curly bracket "}" | Jede geöffnete Klammer muss geschlossen werden
nofill(); | The function "nofill()" does not exist | das Programm kennt den Befehl nicht, dies kann an einem Tippfehler oder der Unterscheidung von Groß- und Kleinschreibung liegen


## Hilfsmittel: Kommentare

Kommentare werden nicht nur genutzt, um sachdienliche Hinweise auf die Funktionsweise zu streuen, sondern auch, um mal eben schnell ein Stück Code rauszunehmen, um das restliche Programm zu testen.

### Warum sind Kommenatre jedoch so wichtig

- Helfen bei der Strukturierung langer Quelltexte
- irgendwann verwendet man so viele Variablen, dass man nicht mehr genau weiß, wofür sie verantwortlich sind
- beim kollaborativen (gemeinschaftlichen) Arbeiten an einem großen Programm, können so Hinweise zum Verständnis gesetzt werden

### Einzeiliger Kommentar

Alles, was nach einem ```//``` steht wird von Processing ignoriert. So können Sie kurze Kommentare hinter eine Codezeile schreiben.

**Beispiel**

```
int alter = 13; // Aktuelles Jahr - Geburtsjahr zählt
String name = “Tom“;

print(“Ich bin “ + name + “ und bin “ + alter + “ alt.“);
```

### Block-Kommentar

Du kannst auch einen ganzen Bereich als ignorierbar erklären. Dazu kennzeichne den Beginn dieses Bereichs mit ```/*``` und das Ende mit ```*/```.

**Beispiel**

```
/* Ein Hund kam in die Küche
und stahl dem Koch ein Ei
da nahm der Koch nen Löffel
und schlug den Hund zu Brei */
println("argh");
```

## Hilfsmittel: Konsole

Manchmal kommen unerwartete Werte bei Berechnungen heraus. Man sollte sich nicht scheuen, die Konsole als einfaches Kontrollwerkzeug zu betrachten.<br />Beispielsweise lässt man sich bei Berechnungen Zwischenwerte in der Konsole ausgeben.

?>Die Konsole ist der schwarze Bereich in dem man Text ausgeben kann.

## Hilfsmittel: Debugger

Eine Fehlersuche bei Variablenbelegungen kann man auch mit Hilfe des Debuggers vollziehen. Dazu musst du den Debugger in der Menüleiste starten und entsprechend gewünschte Variablen durch Anklicken der Codezeilennummer markieren. Diese entsprechend auch sogenannten Stop-Stellen. Probier es aus.