# Lernumgebung Processing - Teil 2

*Dateiname: grafikprogramm.md*

---

![](https://upload.wikimedia.org/wikipedia/commons/thumb/c/cb/Processing_2021_logo.svg/240px-Processing_2021_logo.svg.png)

### Dein erstes Grafikprogramm

## Basics

Oftmals spannender und anwendungsreicher ist das Grafikfenster. Heutzutage bewegt man sich meist in einer **grafischen Benutzeroberfläche** (sogenannte GUI).
Wenn du dein Programm startest, hast du sicher schon festgestellt, dass sich ein **weiteres kleines Fenster** öffnet. Darin können Zeichenbefehle ausgeführt werden. Später wirst du dort eine Spielfigur mit Maus oder Tastatur steuern können.
Teste doch einfach mal folgenden kleinen Befehl:
```
line(10,10,80,80);
```

Damit wir richtig Anfangen können zu zeichnen, gibt es einige Einstellungsmöglichkeiten für die „Zeichenfläche“:
Es wird immer zuerst die **Fenstergröße** festgelegt:

Befehl | Auswirkung
------ | ----------
size(500,500); | Fenstergröße wird auf 500x500 Pixel festgesetzt
fullScreen(); | Bildschirmfüllende Ausgabe

**Hintergrundfarbe**

Befehl | Auswirkung
------ | ----------
background(0); | Werte von 0 bis 255 erzeugen Grautöne von schwarz=0 bis weiß=255
background(255,0,0); | RGB-Werte von 0 bis 255 möglich

**Weitere Farbeinstellungen**

Befehl | Auswirkung
------ | ----------
stroke(255,255,0); | legt Linienfarbe (auch für Figuren) fest
fill(0,255,0) | legt Füllfarbe für Figuren und Schrift fest
noStroke(); | es werden keine Linien gezeichnet
noFill(); | Figuren erhalten keine Füllung
stroke(255,0,0,90); | Auch den Alpha-Kanal kann man steuern

Mit Hilfe des **Tools** „Farbauswahl“ (findest du in der Menü-Leiste) kann man sehr leicht die RGB oder HEX-Werte jeder gewünschten Farbe ermitteln.

### Koordinatensystem

Die Ausdehnung des Koordinatensystems ist im Gegensatz zur Mathematik etwas „unüblich“.

![Koordinatensystem in Processing](bilder/processing_koo.png)

s> **Tipp**: Bei der Platzierung von Objekten bietet sich als Hilfsmittel immer ein kariertes Blatt Papier an.

Doch nun stellt sich die Frage, was man eigentlich alles Zeichnen kann.

### Geometrischen Objekte

Befehl | Auswirkung
------ | ----------
point(x,y); | Pixel setzen
line(x1,y1,x2,y2); | Line mit Anfangs- und Endpunkt
rect(x,y,b,h); | Rechteck mit oberem Eckpunkt (x,y) und Breite (b) sowie Höhe (h)
ellipse(x,y,d1,d2); | Ellipse mit Mittelpunkt (x,y) und vertikalem bzw. horizontalem Durchmesser
triangle(x1,y1,x2,y2,x3,y3); | Dreieck mit 3 Eckpunkten
text("Blabla",x,y); | Textausgabe im Grafikfenster beginnend am Punkt (x,y)

---

## Übung

t>**Aufgabe 1**<br />Zeichne das Haus des Nikolaus in einem Grafikfenster, welches 640x400 Pixel groß ist. Speichere dein Programm unter dem Namen "haus-des-nikolaus" ab.

```
size(600,400);
background(0);
stroke(255);
line(50,200,50,350);
line(200,200,200,350);
...
```

t>**Aufgabe 2**<br />Zeichne die deutsche Flagge. Nutze dazu Rechtecke und wähle eine entsprechende Füllfarbe.

t>**Aufgabe 3**<br />Erstelle ein Programm "gesicht". Erstelle mit Hilfe der Grafikausgabe folgendes Gesicht:

![Aufgabe Gesicht zeichnen](bilder/beispiel-gesicht.png)

*Lösung*

```
HIER EINFÜGEN
```

t>**Aufgabe 4**<br />Zeichne einen Ghettoblaster.

![Ghetto-Blaster](bilder/ghettoblaster.png)

t>**Aufgabe 5**<br />Erstelle ein Kalender-Widget, wie in der Grafik dargestellt ist.

![Widget Beispiel](bilder/beispiel-widget.png)

*Tipp: für die Abrundung des Rechtecks kannst du dir dieses [Beispiel](https://processing.org/reference/rect_.html) anschauen. Für das automatische Auslesen des Monatstages kannst du die Funktion [day()](https://processing.org/reference/day_.html) nutzen.*

---

## Hilfe

![Hilfe-Banner](bilder/hilfe.jpg)

>Aufgabe 1

Bedenke, dass man zuerst den Stift nimmt und damit die Stiftfarbe wählt und erst anschließend geometrische Formen zeichnet. Weiter helfen dir sicher die Befehle `rect(x,y,b,h)` und `fill(255,20,20)`.

>Aufgabe 2

<img src="bilder/haus-des-nikolaus.png" width="300px" />

>Aufgabe 3

Im Grafikfenster wird stets eine Pixelgrafik ausgegeben. Dabei werden lediglich vorhandene Pixel geändert. Entsprechend gilt die Regel *Was zuletzt gezeichnet wird, ist zuerst zu sehen*. Den Mund kann man durch ein Rechteck und zwei halb überlagernde Kreise darstellen. Alternativ kann man auch den Befehl [strokeCap()](https://processing.org/reference/strokeCap_.html) nutzen.

>Aufgabe 4

keine Hilfe vorhanden

>Aufgabe 5

keine Hilfe vorhanden

