# Lernumgebung Processing - Teil 1

*Dateiname: lernumgebung_processing.md*

---

## Lernumgebung Processing

![](https://upload.wikimedia.org/wikipedia/commons/thumb/c/cb/Processing_2021_logo.svg/240px-Processing_2021_logo.svg.png)

- vom **MIT** (Massachusetts Institute of Technology) entwickelt
- ist eine sogenannte **IDE** (integrierte Entwicklungsumgebung, engl. integrated development environment)
- didaktische Weiterentwicklung der **Sprache Java**
- der [Download](https://processing.org/download/) ist für alle üblichen **Betriebssysteme** möglich (Windows, MacOS, Linux)
- auch in den **AppStores** von Android und iOS findest du die Processing-Applikation

### Aufbau des Programms

Programmiert wird in einem sogenannten **Sketch**. In diesem wird der Code geschrieben. Um das Programm anschließend zu starten musst du nur noch hier klicken.

![Processing Oberfläche](bilder/processing-ide.png)*Quelle: https://michaelkipp.de*

Ein **Debugger** zeigt dir schon während des Eintippens mögliche Fehler an. Dazu wird dir eine rote Zeile mit deer entsprechenden Fehlermeldung angezeigt.

![Fehlermeldung](bilder/fehlermeldung_debugger.png)*Quelle: https://michaelkipp.de*

Ein Sketch ist ein Verzeichnis und eine entsprechende **.pde-Datei**. Dies liegt daran, das später auch mehrere Dateien für ein Programm benötigt werden.

w> Zu beachten ist, dass Ordnername und Sketchname **übereinstimmen** müssen. Speicherst du dein Programm, wird dies automatisch übernommen. Lediglich beim Umbenennen von Datei oder Name musst du aufpassen.

--- 

## Und schon geht's los...

### Dein erstes Konsolenprogramm

Für die Ausgabe in der Konsolen sind zwei verschiedene Befehle von Bedeutung:
```
print(“Hallo, “);
println(“Welt.“);
```

Beide Befehle erwarten zunächst Text, diese werden in der Informatik als `Zeichenketten` bezeichnet.
Mit Hilfe eines kleinen Tricks können jedoch auch (berechnete) Zahlen ausgegeben werden. Dazu muss ein Zahl einfach mit einer **Zeichenkette** verbunden werden.

```
int alter = 499;
String name = “der Weihnachtsmann“;

print(“Ich bin “ + name + “ und bin “ + alter + “ alt.“);
```

t>**Aufgabe 1**<br />Probiere dein oben dargestellten Code so abzuwandeln, dass er auf dich passt.

t>**Aufgabe 2**<br />Natürlich kann man in der Konsole auch "zeichnen". Versuche folgende Bilder in der Konsole umzusetzen:

```
Sanduhr:  *****       Pizzastück: **********      Diamant:     **
           ***                     *      *                   *  *
            *                       *    *                   *    *
           ***                       *  *                     *  *
          *****                       **                       **
```


*Lösung für eine Grafik*

```
HIER EINFÜGEN
```

---

### Wann ist die Konsole die erste Wahl

i>**Konsolenprogramme** bieten sich besonders dann an, wenn es um eine Berechnung eines Sachverhaltes geht, ohne das eine grafische Darstellung benötigt wird oder die Interaktion mit Maus und Tastatur irrelevant ist.

t>**Aufgabe**<br />Worin liegt der Unterschied zwischen den Befehlen `print` und `println`?

*Lösung*

- ...

---

## Java - unsere Programmiersprache

**1991**: Java geht auf die Sprache Oak zurück, die von James Gosling und anderen im Green-Projekt (leichtere Programmierung elektronischer Geräte) entwickelt wurde.

**1995**: Java wurde von der Firma Sun als neue, objekt-orientierte, einfache und plattformunabhängige Programmiersprache vorgestellt.

**1996**: Java wurde allgemein in Verbindung mit Web-Browsern und Internet- Anwendungen anerkannt.
Der Name geht auf eine bei amerikanischen Programmierern populäre Bezeichnung für Kaffee zurück.

Die Programmiersprache kann in verschiedenen Programmierumgebungen (sogenannten IDEs) angewandt werden.

**Beispiele**
- Eclipse
- Processing
- Java-Editor

![Der Name Java geht auf eine Kaffeesorte zurück - nett zu wissen](bilder/kaffeetasse.jpg)

---

### Einordnen der Programmiersprache

Java gehört zu den höheren Programmiersprachen. Das heißt, sie ist als menschenähnliche (höhere) Programmiersprache zu verstehen. Sie trägt die Merkmale einer **imperativen** und **objektorientierten** Programmiersprache.

i> **imperativ**: Folge von Anweisungen, die abgearbeitet wird<br />**objektorientiert**: Zusammenspiel verschiedener Objekte, welche Eigenschaften und Fähigkeiten haben

Eingeteilt werden Programmiersprachen nach folgenden

**Paradgimen**

- imperativ
- funktional
- prädikativ
- regelbasiert
- objektorientiert

**Generation**

- erste Generation: Maschinensprache
- zweite Generation: Assemblersprachen
- dritte Generation: höhere Programmiersprachen
- vierte Generation: für Datenbankzugriffe
- fünfte Generation: für Expertensystem
- sechste Generation: grafische Beschreibung

### Weiteres Wissenswertes

- jeder Befehl wird mit einem ```Semikolon``` abgeschlossen
- Java ```unterscheidet``` zwischen Groß- und Kleinbuchstaben
- einige ```Eigennamen``` dürfen nicht verwendet werden
- Java unterscheidet Dateitypen (Zahlen, Wörter, Wahrheitswerte, …)

---

## Interpreter & Compiler

Die sind zwei Elementare Begriffe in der Programmentwicklung.

i>Der **Interpreter** interpretiert den geschriebenen Code innerhalb der Programmierumgebung und macht ihn ausführbar. Dies ist in Processing mittels "Play-Buttons" umgesetzt.

Doch ab und zu möchte man das geschriebene Programm auch ohne IDE ausführen. Dazu muss es compiliert werden, d.h. es wird aus dem geschriebenen Code ein ausführbares Programm generiert.
Dies kannst du erzeugen, indem du auf DATEI -> EXPORTIEREN gehst.

i>Ein **Compiler** erzeugt mit Hilfe der IDE ein ausführbares Programm, welches alleinstehend verwendet werden kann.

Das Compilieren dauert logischerweise etwas länger. Daher hilft uns der Interpreter bei der Überprüfung, ob der bisherige Code unseren Erwartungen entspricht.


