# Programmierprojekt

*Dateiname: programmierprojekt.md*

<img src="bilder/programmierprojekt.png" width="300 px" />

### Zielstellung

Seit mehreren Monaten arbeitest du nun mit der Programmierumgebung Processing und hast dabei alle drei Säulen der Programmierung kennengelernt (Variablennutzung, Programmflusssteuerung und eigene Funktionen).

Ziel dieses Abschlussprojektes soll es nun sein, dein ganzes Wissen in einem selbstständig gewählten Themengebiet zu repräsentieren. Dies kann sehr vielfältig sein und auch mögliche Zeitkapazitäten sprengen. Daher solltest du unbedingt Rücksprache über den Umfang deines gewählten Projektes halten.

### Anforderungen an dein Programm

-	selbsterklärende Oberfläche
-	hohe Leistungsfähigkeit und –umfang
-	Vielfalt der algorithmischen Grundstrukturen
-	Einsatz von selbstdeklarierten Prozeduren und Funktionen mit Parameterübergabe
-	„guter“ Programmierstil
-	besonderes Feature

### Hinweise zur Durchführung

- Programmierung, Planung und Dokumentation **kann** zu Hause erfolgen
- Gegenseitige **Hilfe** durch Mitschüler und Lehrer ist **in geringem Umfang** (einzelne Ideen oder Fehlerbehebung) statthaft
- Es muss jeder Teil des Programms erläutert werden können, sonst besteht der konkrete Verdacht der Täuschung! Es erfolgt eine entsprechende Bewertung

### Inspiration

- Computerspiel (Pacman, Kisten Schieben, Ping-Pong, 4-gewinnt …)
- Foto-Bearbeitungsprogramm
- rekursive Grafiken (ähnlich binärer Bäume)
- 3D-Ansicht eines Hauses (vielfältige Betrachtungsoptionen)
- Bild-aus-Text
- Mathe-Programm: Funktions-Plotter, Thema Wahrscheinlichkeit, …
- Sudoku-Generator
- [https://thecodingtrain.com/](https://thecodingtrain.com/CodingChallenges/)
- [https://hello.processing.org](https://hello.processing.org/display/#@-KwzztJ9J1Np40p8VtSX)

---

### Arbeitsphasen

1. Auswahl des Themas (Hausaufgabe)
2. anschauliche Vorstellung deines Themas
3. Festlegen der Zielbestimmung
  - Musskriterien (muss es können)
  - Wunschkriterien (schön, wenn es dabei ist)
  - Abgrenzungskriterien (soll es nicht können)
4. Planung deines Projektes mit Trello
5. Arbeitsphase
6. Abgabe des Projektes


---

### Planung deines Projektes

t>**Aufgabe**<br />Finde eine Programmidee, die du in deinem Programmierprojekt umsetzen möchtest.

t>**Aufgabe**<br />Finde die Muss-, Wunsch- und Abgrenzungskriterien für dein Projekt.

t>**Aufgabe**<br />Plane dein Programmierprojekt mit Hilfe von Trello. Setze für einzelne Aufgaben auch Zeitstempel (*Frist anpassen*).

t>**Aufgabe**<br />Vervollständige deine Dokumentation am Ende jeder Stunde und bezeichne die Datei mit folgendem Namen: "**8x_Nachname_Vorname_Programmierprojekt_JJMMTT.pdf**" .

s>Ich wünsche dir viel Erfolg beim Arbeiten.

---

### Planung mit Trello

Zur Dokumentation von größeren Projekten gibt es viele Möglichkeiten. Da stehen Begriffe wie Pflichtenheft, Checklisten, Lastenheft oder Projektstrukturplan im Raum. Sowas kann auch digital durchgeführt werden. Eine Möglichkeit ist Trello.
Melde dich auf der Webseite von [Trello](https://trello.com/de) an. Dort musst du einige Dinge eingeben:

- Name des Projektes
- verschiedenen Arbeitsphasen
- konkrete Arbeitsschritte


---

### Bewertung
Kriterium|Bechreibung|mögliche BE
---------|-----------|-----------
Dokumentation|Vollständige Planung des Projekts in Trello| 6 BE
  |Abgabe der Kriterien|3 BE
  |Dokumentieren der getätigen Arbeit (ScreenShot von Trello in fortlaufender Dokumentation reicht)| 3 BE
Programmierung|Verwendung von Kommentaren|2 BE
  |Vielfältigkeit der Grundstrukturen|6 BE
  |Verwendung von Unterprogrammen mit Parametern|4 BE
  |Selbsterklärende Oberfläche oder Erläuterung in weiterem Dokument|2 BE
  |"Guter Programmierstil"|2 BE
  |Variierbarkeit des Programms|2 BE
  |Kreativität| 6 BE
  |Einsatz neuer Komponenten|4 BE
**Summe**|  | **40 BE**

!>Sollte ich den abgegebenen Code unter nicht angegebenen Quellen finden, liegt der Betrugsversuch nah. Sollten auch Rückfragen nicht zufriedenstellend beantwortet werden, wird das Programmierprojekt analog eines Betrugsversuchs gewertet.


---

## Beispielprojekt 1

Dies ist der sogenannte **default**-Fall. Solltest du noch keine Vorstellung von einem Projekt haben, könntest du folgende Aufgabe lösen, mit der du ebenfalls die Basis deines eigenen Programmierprojektes schaffst.

**Thema**

- Erstellen eines Malprogramms

**Funktionsumfang**

- Auswahl von mindestens 3 Farbstiften
- Radiergummi
- 

## Beispielprojekt 2

**Thema**

- Lauflängenkodierung
- Donkey-Kong-Spiel
- IBAN-Generator
- Pirat-Kanone-Spiel
- Angry-Birds
- Ping-Pong
- Snake
- Foto-Filter
- Physikalisches Experiment zum selber machen
- Simulation Gesetz der großen Zahlen
- Game of Life
- Blockly
- QR-Code-Generator
- Galton-Brett-Simulation
