# Programmierprojekt

*Dateiname: programmierprojekt.md*

<img src="bilder/programmierprojekt.png" width="300 px" />

### Zielstellung

Seit mehreren Monaten arbeitest du nun mit der Programmierumgebung Processing und hast dabei alle drei Säulen der Programmierung kennengelernt (Variablennutzung, Programmflusssteuerung und eigene Funktionen).

Ziel dieses Abschlussprojektes soll es nun sein, dein ganzes Wissen in einem selbstständig gewählten Themengebiet zu repräsentieren. Dies kann sehr vielfältig sein und auch mögliche Zeitkapazitäten sprengen. Daher solltest du unbedingt Rücksprache über den Umfang deines gewählten Projektes halten.

### Anforderungen an dein Programm

-	selbsterklärende Oberfläche
-	hohe Leistungsfähigkeit und –umfang
-	Vielfalt der algorithmischen Grundstrukturen
-	Einsatz von selbstdeklarierten Prozeduren und Funktionen mit Parameterübergabe
-	„guter“ Programmierstil
-	besonderes Feature

### Hinweise zur Durchführung

- Programmierung, Planung und Dokumentation **kann** zu Hause erfolgen
- Gegenseitige **Hilfe** durch Mitschüler und Lehrer ist **in geringem Umfang** (einzelne Ideen oder Fehlerbehebung) statthaft
- Es muss jeder Teil des Programms erläutert werden können, sonst besteht der konkrete Verdacht der Täuschung! Es erfolgt eine entsprechende Bewertung

### Programminhalt

Entwickle ein Lernprogramm für die Schule. Welcher Bereich bzw. für welche Klassenstufe ist dabei offen gelassen. Du kannst dich auch an Grundschülern orientieren.
Solltest du eine komplett andere Idee haben, gehe mit deinem Fachlehrer ins Gespräch und besprecht diese Idee.


---

### Arbeitsphasen

1. Auswahl des Themas (Hausaufgabe)
2. Festlegen der Zielbestimmung
  - Musskriterien (muss es können)
  - Wunschkriterien (schön, wenn es dabei ist)
  - Abgrenzungskriterien (soll es nicht können)
3. Arbeitsphase
4. Abgabe des Projektes (2. Woche nach den Februar-Ferien)


---

### Planung deines Projektes

t>**Aufgabe**<br />Finde eine Programmidee, die du in deinem Programmierprojekt umsetzen möchtest.

t>**Aufgabe**<br />Finde die Muss-, Wunsch- und Abgrenzungskriterien für dein Projekt.

s>Ich wünsche dir viel Erfolg beim Arbeiten.

---

### Bewertung

Kriterium|Bechreibung|mögliche BE
---------|-----------|-----------
Programmierung|Verwendung von Kommentaren|2 BE
  |Verwendung aller Grundstrukturen|6 BE
  |Verwendung von Unterprogrammen mit Parametern|4 BE
  |Selbsterklärende Oberfläche oder Erläuterung in weiterem Dokument|2 BE
  |"Guter Programmierstil"|2 BE
  |Kreativität| 6 BE
  |Einsatz neuer Komponenten|4 BE
**Summe**|  | **26 BE**

!>Sollte ich den abgegebenen Code unter nicht angegebenen Quellen finden, liegt der Betrugsversuch nah. Sollten auch Rückfragen nicht zufriedenstellend beantwortet werden, wird das Programmierprojekt analog eines Betrugsversuchs gewertet.


---

## Beispielprojekt 1

Dies ist der sogenannte **default**-Fall. Solltest du noch keine Vorstellung von einem Projekt haben, könntest du folgende Aufgabe lösen, mit der du ebenfalls die Basis deines eigenen Programmierprojektes schaffst.

**Thema**

- Bruchrechenprogramm

**Funktionsumfang**

- zufälliges Generieren von Brüchen
- korrekte Berechnung
- sinnvolle Eingabemöglichkeit
- angemessene Reeaktion auf gekürzte und ungekürzte Rechenergebnisse
- Speichern in einer Datei (als Einsatz neuer Komponenten)
