# Schleifen im aktiven Modus
*Dateiname: schleifen_aktiver_modus.md*

Wichtig: In Processing benutzt man Schleifen normalerweise **nicht für Animationen**. Du könntest auf die Idee kommen, einen Ball innerhalb von einer For-Schleife zu animieren.

```
// (vergeblicher) Versuch einer Animation

int x = 0;

void setup() {
  frameRate(1); // 1x pro Sek. draw() aufrufen
}

void draw() {
  for (int i = 0; i < 100; i++) {
    background(255);
    ellipse(x, 50, 10, 10);
    x++;
  }
  // erst jetzt wird das Werk sichtbar!
}
```

Hier ist die Frame-Rate auf 1 gesetzt, d.h. `draw()` wird jede Sekunde aufgerufen. Du siehst eine Sekunde dne Ball in seiner "Endposition" und danach wird es weiß. Warum?
Weil Processing am Ende von `draw()` die Zeichnung sichtbar macht. Alles was innerhalb von `draw()` passiert, ist somit unsichtbar, bis die schließende geschweifte Klammer von `draw()` erreicht ist.

Sinnvoller ist es daher, wiederkehrende grafische Elemente mit Hilfe von Schleifen zu erstellen. So kann man beispielsweise drei Rechtecke gleichzeitig malen:

```
// Drei Rechtecke mit Schleife

int x = 0;

void draw() {
  background(255);

  // zeichne drei Rechtecke, i läuft von 1..3
  for (int i = 1; i <= 3; i++) {
    rect(x, i * 20, 10, 10); // jedes hat andere y-Position
  }

  // passe x-Wert an für Animation
  x++;
}
```

t>**Aufgabe**<br />Fülle den Schreibtischtest aus.

*Lösung*

Durchlauf Nr. | Wert von i | i <= 3 | ausgeführter Code
--------------|------------|--------|------------------
              |            |        |  
              |            |        |  
              |            |        |  

t>**Aufgabe**<br />Beschreibe das Verhalten der drei Rechtecke innerhalb des Schleifenzyklus bzw. der draw()-Methode.

*Lösung*

