# Verschachtelte Zählschleife
*Dateiname: schleifen_zaehlschleife_verschachtelt.md*

Eine Tabelle in einer Tabellenkalkulation besteht aus Zeilen und Spalten, die durchnummeriert sind. So kann man jede Zelle über Zeilen- und Spaltennummer ansprechen:

   - |0|1|2
-----|-|-|-
**0**| | | 
**1**| | | 
**2**| | | 

Das gleiche Prinzip findet sich in Gleichungssystemen bzw. Matrizen oder einem Schachbrett wieder.
Jetzt kann es sein, dass du alle Einträge auf Null setzen musst. Dazu müssen alle Kombinationen von Zeilen- und Spaltennummern durchlaufen werden.

Es ist recht einfach, mit einer For-Schleife alle Zeilen zu durchlaufen:

```
for (int z = 0; z < 3; z++) {
  println("Zeile " + z);
}
```

Genau so leicht ist es, alle Spalten zu durchlaufen:

```
for (int s = 0; s < 3; s++) {
  println("Spalte " + s);
}
```

Jetzt möchtest du für Zeile 0 alle Spalten 0,1,2 durchlaufen, dann für Zeile 1 und analog für Zeile 2. Das erreichst du, indem du innerhalb der ersten For-Schleife (Zeilen) die zweite For-Schleife (Spalten) laufen lässt:

```
for (int z = 0; z < 3; z++) {

  for (int s = 0; s < 3; s++) {
    println("Zeile " + z + ", Spalte " + s);
  }
}
```

i>Man spricht hier von zwei *verschachtelten* For-Schleifen. Dabei ist die Zeilenschleife die **äußere Schleife** und die Spaltenschleife die **innere Schleife**.

Verschachtelte Schleifen kommen immer dann zum Einsatz, wenn eine zweidimensionale Struktur abgeschritten werden soll. Dies kann man sich im einfachsten Fall als Tabelle (siehe oben) vorstellen.

Gerade im grafischen Bereich kann man 2-dimensionale Strukturen gebrauchen, z.B. das folgende Gittermuster:

```
for (int x = 0; x <= 100; x = x + 25) {
  for (int y = 0; y <= 100; y = y + 25) {
    ellipse(x, y, 10, 10);
  }
}
```

t>**Aufgabe**<br />Probiere es aus!

w>Beachte, dass hier spaltenweise gezeichnet wird. Erst wird die x-Koordinate auf 0 fixiert und wir durchlaufen y=0, y=25 usw. Danach wird x auf 25 gesetzt und y durchlaufen mit y=0, y=25 usw. Natürlich könnte man in diesem Beispiel auch zeilenweise zeichnen, dazu müsste man y in die äußere Schleife verlagern.

---

### Übung

t>**Aufgabe Schachbrett**<br />Zeichne ein Schachbrettmuster.

t>**Aufgabe Mosaikmuster**<br />Erzeuge 30 x 60 Quadrate mit jeweils 15 Pixel Kantenlänge. Jedes Quadrat soll eine zufällige Farbe erhalten.

t>**Aufgabe Muster I**<br />Erzeuge folgendes Muster:

![schleifen_verschachtelt_Muster1](bilder/schleifen_verschachtelt_Muster1.png)

t>**Aufgabe Muster II**<br />Erzeuge folgendes Muster:

![schleifen_verschachtelt_Muster1](bilder/schleifen_verschachtelt_Muster2.png)

t>**Aufgabe**<br />Erzeuge 100 Quadrate, welche ja nach Mausposition die Farbe ändern.

![schleifen_verschachtelt_Muster1](bilder/schleifen_verschachtelt_Muster3.png)

t>**Aufgabe Matrix**<br />Das hellgrüne Zentrum soll sich stets da befinden, wo die Maus ist.

![schleifen_verschachtelt_Muster1](bilder/schleifen_verschachtelt_Muster4.png)