# Arrays / Felder

*Dateiname: vertiefung_array.md*

### Allgemeines

Oft ist es sinnvoll mehrere Variablen oder Objekte eines gleichen Types (z.B. Integer, String) unter einem Namen zusammenzufassen. Dabei können die verschiedenen Feldelemente über ihren Index (Platznummer, beginnt bei 0) aufgerufen werden.
Dies wird beispielsweise beim Speichern der verschiedenen Pixel bei der Methode `loadImage()` verwendet.


### Beispiel

Es sollen 24 Schüler eines Kurses erfasst werden:

`Schueler[5] = "Schulze, Claudia"` (hier ein Feld von Strings)

*NameDesFeldes[Index] = SchülerAnStelle5*

i>Informatiker fangen bei 0 an zu zählen...also 24 Schüler bedeutet von Index 0 bis 23

### Deklaration

```
Typ Name[] = new Typ[Anzahl];
String Schueler[] = new String[24];
double temperatur[] = new double[100];
```


- falls Felder im Typ und Index übereinstimmen, so ist eine **Zuweisung** (z.B. `temperatur1 = temperatur2;`) möglich
- Index kann auch ein Rechenausdruck sein: `Schueler[2*i+1]`


## Zwei- und mehrdimensionale Felder

Es sollen 5 Messreihen zu je 20 Messungen durchgeführt werden:

### Deklaration

```
double messwert[][] = new double[5][20];
```

- 5 ist der Zeilenindex
- 20 ist der Spaltenindex
- **Gebrauch:** `messwert[2,5]` enthält den Wert aus der 2. Zeile und 5. Spalte
- höherdimensionale Felder werden entsprechend vereinbart

## Wichtige Befehle

Befehl | Erläuterung
-------|------------
Feld[1] = 5; | speichert den Wert 5 beim eindimensionalen Feld an die Stelle 2
Feld[1,2] = 5 | speichert den Wert 5 in das Feld in die erste Zeile und zweite Spalte
println(Feld[1]); | gibt den Inhalt von dem ersten Feld in der Konsole aus
Feld.length | gibt die Anzahl der (möglichen) Feld-Elemente zurück
Feld.sort(values) | sortiert die entsprechenden Feldelemente


