# Rekursion

*Dateiname: vertiefung_rekursion.md*

### Grundgedanke der Rekursion

Die Rekursion ist eine Wiederholung, die durch Ineinanderschachtelung von Pro-zeduren bzw. Funktionen erreicht wird.
Dabei ruft sich die Methode mit ständig vereinfachten Parametern selbst auf (soge-nannter **Rekursionsschritt**), bis der Parameter seinen einfachsten Wert erreicht hat (sogenannte **Abbruchbedingung**).

### Rekursive Definition der Quadratsummenfunktion

- **Abbruchbedingung**: quad_sum(1) = 1 (*fertig!*)
- **Rekursionsschritt**: ansonsten ist die Quadratsumme die Zahl^2 plus die Quadratsumme vom Vorgänger, d.h.<br />quad_sum(zahl) = zahl*zahl + quad_sum(zahl-1);

```
int quad_sum(int zahl){
  if(zahl == 1){
    return 1;
  } else {
      return zahl*zahl + quad_sum(zahl - 1);
    }
}
```

Hier ruft sich die Funktion ständig selbst auf.

**Vorteil**: kürzer und weniger Variablen, einfacher zu programmieren
**Nachteil**: schwerer zu durchschauen, meist rechenineffizienter

### Erläuterung für quad_sum(4)

```
quad_sum(4) = 4^2 + quad_sum(3);             30
                    3^2 + quad_sum(2)        14                    
                          2^2 + quad_sum(1)  5
                                1            1                                
                  Rekursiver Abstieg         Rekursiver Aufstieg
```

## Übung

t>**Aufgabe**<br />Ändere das Programm zur Fakultätsberechnung ( 4! = 4 * 3 * 2 * 1) so ab, dass es ei-ne rekursive Funktion nutzt.

t>**Aufgabe**<br />Zeichne das Schema des rekursiven Auf- und Abstiegs für das Beispiel mFunk(4).

```
int mFunk(int zahl) {
    if (zahl == 1) {return 3;}
 else {return 2 * mFunk(zahl - 1)+1;}
  }

```

t>**Aufgabe**<br />Ändere das Programm zur Potenzberechnung ( ab=a*a*a*..*a ) so ab, dass es eine rekursive Funktion nutzt.

t>Entwirf ein Programm zu Summenberechnung von Anfangszahl bis Endzahl ( 3 + 4+ 5+ 6 ) mit Hilfe einer rekursiven Funktion. Zeichne das Schema des rekursiven Auf- und Abstiegs für ein Beispiel
