# Übung: Verzweigung

*Dateiname: verzweigung_ubung.md*


## Schwierigkeitsstufe 1

t>**Aufgabe 1.1 - Paschprüfer**<br />Erstelle ein Programm, bei dem mit Hilfe eines Mausklicks zwei Würfel geworfen werden. Gib die Augenzahlen in der Konsole aus. Sollten beide Würfel dieselbe Augenzahl haben, soll zusätzlich das Wort „Pasch“ erscheinen.

*Du benötigst: zwei globale Variablen, Zufallszahlen, Verzweigung*

t>**Aufgabe 1.2 - gerade/ungerade**<br />Schreibe ein Programm für folgende Bedingung und teste mit Hilfe verschiedener Beispiele. Gegeben sei eine int-Variable zahl. Wenn die Zahl gerade ist, soll „gerade“ ausgegeben werden – ansonsten „ungerade“.

t>**Aufgabe 1.3 - Radarmesser**<br />Erlaubt ist eine Geschwindigkeit von 50 km/h. Es wird eine Radarmessung durchgeführt und die Information in einer Variablen gespeichert. Der Algorithmus soll entscheiden, ob der Fahrer angemessen fährt oder eine Geschwindigkeitsübertretung verübt wurde. Die Information soll in der Konsole ausgegeben werden.

## Schwierigkeitsstufe 2

t>**Aufgabe 2.1 - stehender Ball**<br />Ändere das folgende Programm derart, dass der Ball stehenbleibt, sobald er die Mitte erreicht hat.

```
int x = 0;

void draw() {
  background(255);
  ellipse(x, 50, 20, 20);
  x++;

  if (x > width) {
    x = 0;
  }
}
```

t>**Aufgabe 2.2 - Downloadbalken**<br />Erstelle einen Ladebalken (Rechteck), der mit der Breite 0 startet und sich bis zu einer bestimmten Breite vergrößert. 

![Verzweigung Einführung Flussdiagramm](bilder/verzweigungDownloadBalken.png)

t>**Aufgabe 2.3 - Wachsen**<br />Ein mittig platzierter Kreis wird stetig größer, bis er den Rand des Fensters erreicht, dann beginnt er wieder als ein kleiner Kreis zu wachsen.

t>**Aufgabe 2.4 - mutierter Mauszeiger**<br />Folgendes Programm erzeugt einen Mauszeiger in Form eines Kreises. Verändern Sie das Programm derart, dass in der rechten Bildschirmhäfte der Mauszeiger zur gefüllten, schwarzen Box wird (mittig zum Mauszeiger) und in der linken wieder zum leeren Kreis.

*Weitere spannende Informationen zum Mauszeiger findest du* [hier](https://processing.org/reference/cursor_.html).

## Schwierigkeitsstufe 3

t>**Aufgabe 3.1 - Ampel**<br />Realisiere mit einem Grafikfenster eine Ampelschaltung.
Tipp: Nutze dafür einen „Zähler“, welcher bei 1 beginnt und die Ampel bei rot steht. Erreicht der Zähler den Wert 14 wird auf Grün, bei 25 auf gelb geschaltet. Bei 30 soll den Zähler von vorn beginnen. Gib den „Zähler“ zur Kontrolle in der Konsole aus. 

t>**Aufgabe 3.2 - Stoppuhr (schwer)**<br />Programmiere eine Art Stoppuhr-Anzeige, die immer wieder von vorn beginnt.

![Stoppuhr](bilder/verzweigungStoppuhr.png)

*Tipp: Nutze die Funktion `arc()`, die ein Kreissegment zeichnet. Denke daran, dass der erste Winkel kleiner als der zweite sein muss. Du kannst auch negative Winkel verwenden.*

