# Zufall

*Dateiname: zufall.md*

![Zufall-Banner](bilder/zufall-banner.jpg)

### Lernziele

?> Du verstehst, wie der Computer eine zufällige Zahl generiert.<br />
 Du kannst eine zufällige Zahl mit dem Computer generieren.<br />
 Du kannst Zufallszahlen zielgerichtet einsetzen (bspw. beim Platzieren von Objekten oder der Farbgenerierung).

---

## Basiswissen

Zufall ist ja so eine ganz spezielle Sache in der Informatik.
Es stellt sich die Frage, ob wir überhaupt von generiertem Zufall sprechen „dürfen“.

t>**Aufgabe**<br />Was versteht man unter "Pseudozufall"?

*Lösung*

- ...

Dennoch bietet es sich an, immer wieder „Unvorhersehbares“ in Programmen zu integrieren. Dazu bietet uns Processing folgenden Befehl `random()`. Diese Funktion gibt an der notierten Stelle eine entsprechende Zufallszahl zurück.
Folgende Abwandlungsmöglichkeiten stehen uns zur Verfügung:
- `fill(random(255));` //zufällige Zahl aus {0,1,…,255}
ellipse(50,50,50,50);
- Der Befehl `random()` gibt eine float-Zahl (Kommazahl) zwischen 0 und 1 zurück.
- Der Befehl `random(-5,5)` erzeugt eine float-Zahl zwischen -5 und 5.

---

## Übung

t>**Aufgabe 1 - Konfetti**<br />Erzeuge einen Konfetti-Regen, bei dem viele bunte Punkte an vielen zufälligen Stellen entstehen.

?>`double d = random(0,1);` //erzeugt eine Zufallszahl zwischen 0 und 1.<br />`(int)` beschneidet die Nachkommastellen<br />`double d = (int) (random(3,6)+1);` erzeugt eine Zufallszahl  zwischen 3 und 6.


t>**Aufgabe 2 - Zufallskästchen**<br />Bei Mausklick soll an zufälliger Position ein Kasten erscheinen, mit zufälliger Breite und Höhe (je zwischen 5 und 40 Pixel).

t>**Aufgabe 3 - Spielwürfel**<br />Erzeuge einen Würfel, welcher die Augenzahl in der Konsole ausgibt.  Der Datentyp Integer (`int`) beinhaltet alle ganzen Zahlen.